
!TOSearch methodsFor: '*tode-pharo-views' stamp: 'dkh 5/30/2011 09:54'!
classQueryResults
	^self classResultsFor: [:cl | self classSatisfiesQuery: cl query: searchText]! !

!TOSearch methodsFor: '*tode-pharo-views' stamp: 'dkh 5/30/2011 08:29'!
classResultsFor: queryBlock
	^ SystemNavigation default allClasses select: [ :ea | queryBlock value: ea ]! !

!TOSearch methodsFor: '*tode-pharo-views' stamp: 'dkh 5/30/2011 09:56'!
methodQueryResults
	| nav methods |
	nav := SystemNavigation default.
	methods := OrderedCollection new.
	(Symbol selectorsContaining: searchText) 
		do: [:ea | (nav allClassesImplementing: ea) do: [:cl | 
				methods add: (MethodReference class: cl selector: ea )]].
	^ methods sorted: [:a :b | a selector <= b selector ]! !

!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:10'!
doit: aString main: main
	^ self
		handleExceptionsDuring: [ 
			Compiler new
				evaluate: aString
				in: nil
				to: self object
				notifying: nil
				ifFail: [ ^ #failedDoit ] ]
		main: main! !

!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:31'!
handleExceptions: exceptionSet during: aBlock main: main
	^aBlock
		on: Halt , Error, exceptionSet
		do: [ :ex | 
			| process |
			process := Processor activeProcess.
			(ProcessBrowser isUIProcess: process)
				ifTrue: [ UnhandledError signalForException: ex ]
				ifFalse: [ 
					self
						pushit:
							((TOException new)
								exception: ex)
						selecting: #debug
						main: main.
					TOErrorCommand signal ] ]! !

!TOObject methodsFor: '*tode-pharo-views' stamp: 'dkh 5/29/2011 17:27'!
handleExceptionsDuring: aBlock main: main
	^aBlock
		on: Halt , Error
		do: [ :ex | 
			| process |
			process := Processor activeProcess.
			(ProcessBrowser isUIProcess: process)
				ifTrue: [ UnhandledError signalForException: ex ]
				ifFalse: [ 
					self
						pushit:
							((TOException new)
								exception: ex)
						selecting: #debug
						main: main.
					TOErrorCommand signal ] ]! !
